GammalL.ib - Bug #1605

Correct library post processing on El Capitan
12/16/2015 10:36 PM - Knédlseder Jirgen
Description
Michael Mayer noted the following:

Note that since a few days, when | modify the python interface, | need make clean and a full rebuild to make it run again. Otherwise |
get the following error messages (don't know if this is just a problem on my machine):

Post process module build/gammalib/_app.so

error: install_name_tool: for: build/gammalib/_app.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_app.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_base.so

error: install_name_tool: for: build/gammalib/_base.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_base.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_com.so

error: install_name_tool: for: build/gammalib/_com.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_com.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_cta.so

Post process module build/gammalib/_fits.so

error: install_name_tool: for: build/gammalib/_fits.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_fits.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_lat.so

error: install_name_tool: for: build/gammalib/_lat.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_lat.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_linalg.so

error: install_name_tool: for: build/gammalib/_linalg.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_linalg.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_model.so

error: install_name_tool: for: build/gammalib/_model.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_model.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_mwl.so

error: install_name_tool: for: build/gammalib/_mwl.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_mwl.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_numerics.so

error: install_name_tool: for: build/gammalib/_numerics.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_numerics.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_obs.so

error: install_name_tool: for: build/gammalib/_obs.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_obs.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_opt.so

error: install_name_tool: for: build/gammalib/_opt.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_opt.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_sky.so

error: install_name_tool: for: build/gammalib/_sky.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_sky.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_support.so

error: install_name_tool: for: build/gammalib/_support.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_support.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_test.so

error: install_name_tool: for: build/gammalib/_test.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_test.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_vo.so

error: install_name_tool: for: build/gammalib/_vo.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_vo.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

Post process module build/gammalib/_xml.so

error: install_name_tool: for: build/gammalib/_xml.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_xml.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs
Post process module build/gammalib/_xspec.so

error: install_name_tool: for: build/gammalib/_xspec.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/lib" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/lib

error: install_name_tool: for: build/gammalib/_xspec.so (for architecture x86_64) option "-add_rpath
/Users/mimayer/Software/gammalib/src/.libs" would duplicate path, file already has LC_RPATH for:
/Users/mimayer/Software/gammalib/src/.libs

make[2]: *** [build] Error 1

make[1]: *** [install] Error 2

make: *** [install-recursive] Error 1

The probable cause is the post processing introduced for El Capitan. If the post processing is applied to a library that has already
been post processed, the errors should occur.

History

#1 - 12/17/2015 02:09 AM - Knddiseder Jiirgen

Note that otool -I can be used to check whether a load path exists:

$ otool -I src/.libs/libgamma.dylib | grep "path test"
path test (offset 12)

Furthermore, we can test whether an output is empty or not using:

$ if [[ $(otool -I src/.libs/libgamma.dylib | grep "path test") ]]; then echo "yes"; else echo "no"; fi

#2 - 12/17/2015 02:20 AM - Knddlseder Jiirgen

- Status changed from New to Feedback

See also https://www.gnu.org/software/make/manual/html_node/Errors.html for a nice way to simply ignore errors.

| implemented this and pushed into devel. You still get the verbose output, but it should no longer lead to an error. Tell me Michael if this works for
you.

#3 - 12/17/2015 09:53 AM - Mayer Michael

- Status changed from Feedback to Resolved

Thanks, it now works. | don't get errors any more when updating the python interface.

#4 - 12/17/2015 02:09 PM - Knodlseder Jiirgen

- Status changed from Resolved to Closed
